'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.ActionMenu = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Button = require('./../Button');

var _Button2 = _interopRequireDefault(_Button);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Transition = require('react-transition-group/Transition');

var _Transition2 = _interopRequireDefault(_Transition);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ActionMenu = exports.ActionMenu = function (_Component) {
	_inherits(ActionMenu, _Component);

	function ActionMenu(props) {
		_classCallCheck(this, ActionMenu);

		var _this = _possibleConstructorReturn(this, (ActionMenu.__proto__ || Object.getPrototypeOf(ActionMenu)).call(this, props));

		_this.handleOpen = function (openEvent) {
			_this.setState({ isOpen: !_this.state.isOpen });
		};

		_this.render = function () {
			var id = _this.props.id;
			var isOpen = _this.state.isOpen;


			return _react2.default.createElement(
				'div',
				{ id: id,
					tabIndex: '0',
					className: 'cp-ActionMenu-holder ' + (isOpen ? 'has-actionMenuOpen' : ''),
					'data-label': 'Actions' },
				_react2.default.createElement(
					'button',
					{ className: 'cp-ActionMenu-btn cp-OpenActionMenu ' + (isOpen ? 'is-open' : ''),
						onClick: _this.handleOpen },
					_react2.default.createElement(
						'svg',
						{ className: 'cp-ActionMenu-icon' },
						_react2.default.createElement('use', { xlinkHref: '#iconTools' })
					),
					_react2.default.createElement(
						'span',
						{ className: 'cp-ActionMenu-text' },
						'Actions'
					),
					_react2.default.createElement(
						'svg',
						{ className: 'cp-ActionMenu-arrow' },
						_react2.default.createElement('use', { xlinkHref: '#iconArrow--down' })
					)
				),
				_this.renderMenu()
			);
		};

		_this.renderMenu = function () {
			var _this$props = _this.props,
			    id = _this$props.id,
			    options = _this$props.options,
			    transitionTimeout = _this$props.transitionTimeout;
			var isOpen = _this.state.isOpen;

			var transitionProps = { in: isOpen, timeout: transitionTimeout };

			var optionDivs = options.map(function (option, index) {
				var optionId = id + 'Option' + index;
				return _react2.default.createElement(
					'li',
					{ key: index },
					_react2.default.createElement(
						_Button2.default,
						{ className: 'cp-ActionMenu-' + option.text,
							id: optionId,
							noStyles: true,
							href: option.url },
						option.text
					)
				);
			});
			return _react2.default.createElement(
				_Transition2.default,
				transitionProps,
				function (state) {
					return _react2.default.createElement(
						'ul',
						{ className: 'cp-ActionMenu ActionMenu-fade-' + state },
						optionDivs
					);
				}
			);
		};

		_this.state = {
			isOpen: false
		};
		return _this;
	}

	return ActionMenu;
}(_react.Component);

ActionMenu.propTypes = {
	/** isOpen sets the standard state of the ActionMenu dropdown */
	isOpen: _propTypes2.default.bool,
	/** options sets the choices presented in the ActionMenu dropdown */
	options: _propTypes2.default.array.isRequired,
	transitionTimeout: _propTypes2.default.oneOfType([_propTypes2.default.shape({ enter: _propTypes2.default.number, exit: _propTypes2.default.number }), _propTypes2.default.number])
};
ActionMenu.defaultProps = {
	transitionTimeout: 240,
	onChange: function onChange(e) {}
};
exports.default = ActionMenu;