The CivicPlus Table
```js
const { Column } = require('../Column/Column.js')
const { CPTableTemplates } = require('./CPTable.js')

let nameTemplate = function(rowData, column) {
    return <a href="#">{rowData.name}</a>;
};

let ownerTemplate = function(rowData, column) {
    return <a href="#">{ rowData.owners.length > 3 ? rowData.owners.length + ' Owners' :
                                                    rowData.owners.join(', ') }</a>
};

let applicationTemplate = function(rowData, column) { 
    return <a href="#">{rowData.applications} Applications</a>
};

let actionsTemplate = function(rowData, column) {
    return  <ActionMenu id="orgActionMenu" options={[
                {"text": "Modify", "url":"/Organization/" + row.Id },
                {"text": "Groups", "url":"/Groups/" + row.Id }
            ]} />
};

const data = [{
                name: 'City of Manhattan, KS',
                owners: ['Bill Murray'],
                applications: 2,
                actions: ['Modify', 'Remove']
            },
            {
                name: 'Maricopa County',
                owners: ['Dan Aykroyd', 'Harold Ramis', 'Ernie Hudson'],
                applications: 2,
                actions: ['Modify', 'Remove']
            },
            {
                name: 'McKinney, TX',
                owners: ['Dan Aykroyd', 'Harold Ramis', 'Ernie Hudson', 'Bill Murray'],
                applications: 0,
                actions: ['Modify', 'Remove']
            }];

<CPTable value={data} sortField={'name'} sortOrder={1}>
    <Column key={'name'} field={'name'} body={nameTemplate} header={CPTableTemplates.headerTemplate} headerText={'Organization'} sortable={true} />   
    <Column key={'owners'} field={'owners'} body={ownerTemplate} header={CPTableTemplates.headerTemplate} headerText={'Owner'} sortable={true} className={'cp-ModuleManage-nextLevel'} />
    <Column key={'applications'} field={'applications'} body={applicationTemplate} header={CPTableTemplates.headerTemplate} headerText={'Applications'} sortable={true} />
    <Column key={'actions'} field={'actions'} body={actionsTemplate} header={CPTableTemplates.headerTemplate} headerText={'Actions'} className={'cp-Tbl-cell--actions'} />
</CPTable>
```