'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.FileUpload = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _blacklist = require('blacklist');

var _blacklist2 = _interopRequireDefault(_blacklist);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Button = require('./../Button');

var _Button2 = _interopRequireDefault(_Button);

var _Spinner = require('./../Spinner');

var _Spinner2 = _interopRequireDefault(_Spinner);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FileUpload = exports.FileUpload = function (_Component) {
	_inherits(FileUpload, _Component);

	function FileUpload() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, FileUpload);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = FileUpload.__proto__ || Object.getPrototypeOf(FileUpload)).call.apply(_ref, [this].concat(args))), _this), _this.getInitialState = function () {
			return {
				dataURI: null,
				file: {},
				loading: false
			};
		}, _this.componentDidMount = function () {
			_this.refs.fileInput.addEventListener('click', function () {
				_this.value = '';
			}, false);
		}, _this.triggerFileBrowser = function () {
			_this.refs.fileInput.click();
		}, _this.handleChange = function (e) {
			var reader = new FileReader();
			var file = e.target.files[0];

			reader.readAsDataURL(file);

			reader.onloadstart = function () {
				_this.setState({
					loading: true
				});
			};
			reader.onloadend = function (upload) {
				_this.setState({
					loading: false,
					file: file,
					dataURI: upload.target.result
				});
				if (typeof _this.props.onChange === 'function') {
					_this.props.onChange(e, {
						file: file,
						dataURI: upload.target.result
					});
				}
			};
		}, _this.cancelUpload = function (e) {
			_this.setState({
				dataURI: null,
				file: {}
			});
			_this.props.onChange(e, null);
		}, _this.render = function () {
			var _this$state = _this.state,
			    dataURI = _this$state.dataURI,
			    file = _this$state.file;
			// props

			var props = (0, _blacklist2.default)(_this.props, 'buttonClassChange', 'buttonClassInitial', 'buttonLabelChange', 'buttonLabelInitial', 'disabled', 'file', 'onChange');
			// elements
			var component = dataURI ? _react2.default.createElement(
				'div',
				{ className: 'FileUpload' },
				_react2.default.createElement(
					'div',
					{ className: 'FileUpload__image' },
					_react2.default.createElement('img', { alt: 'File Upload', className: 'FileUpload__image-src', src: dataURI })
				),
				_react2.default.createElement(
					'div',
					{ className: 'FileUpload__content' },
					_react2.default.createElement(
						'div',
						{ className: 'FileUpload__message' },
						file.name,
						' (',
						Math.round(file.size / 1024),
						'Kb)'
					),
					_react2.default.createElement(
						'div',
						{ className: 'FileUpload__buttons' },
						_react2.default.createElement(
							_Button2.default,
							{ onClick: _this.triggerFileBrowser, disabled: _this.state.loading },
							_this.state.loading && _react2.default.createElement(_Spinner2.default, null),
							_this.props.buttonLabelChange
						),
						_react2.default.createElement(
							_Button2.default,
							{ onClick: _this.cancelUpload, type: 'link-cancel', disabled: _this.state.loading },
							'Cancel'
						)
					)
				)
			) : _react2.default.createElement(
				_Button2.default,
				{ onClick: _this.triggerFileBrowser, disabled: _this.props.disabled || _this.state.loading },
				_this.state.loading ? _react2.default.createElement(_Spinner2.default, null) : null,
				_this.props.buttonLabelInitial
			);

			return _react2.default.createElement(
				'div',
				null,
				component,
				_react2.default.createElement('input', _extends({ style: { display: 'none' }, type: 'file', ref: 'fileInput', onChange: _this.handleChange }, props))
			);
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	return FileUpload;
}(_react.Component);

FileUpload.propTypes = {
	buttonLabelChange: _propTypes2.default.string,
	buttonLabelInitial: _propTypes2.default.string,
	disabled: _propTypes2.default.bool,
	file: _propTypes2.default.object, // https://developer.mozilla.org/en/docs/Using_files_from_web_applications
	onChange: _propTypes2.default.func
};
FileUpload.defaultProps = {
	buttonLabelInitial: 'Upload File',
	buttonLabelChange: 'Change File'
};
exports.default = FileUpload;