'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.Pagination = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Page = function (_Component) {
	_inherits(Page, _Component);

	function Page() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, Page);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Page.__proto__ || Object.getPrototypeOf(Page)).call.apply(_ref, [this].concat(args))), _this), _this.onSelect = function () {
			_this.props.onSelect(_this.props.page);
		}, _this.render = function () {
			var _this$props = _this.props,
			    children = _this$props.children,
			    selected = _this$props.selected;

			var className = (0, _classnames2.default)('Pagination__list__item', {
				'is-selected': selected
			});
			return _react2.default.createElement(
				'button',
				{ className: className, onClick: _this.onSelect },
				children
			);
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	return Page;
}(_react.Component);

Page.propTypes = {
	children: _propTypes2.default.node,
	label: _propTypes2.default.string,
	onSelect: _propTypes2.default.func,
	page: _propTypes2.default.number,
	selected: _propTypes2.default.bool
};


function range(props) {
	var currentPage = props.currentPage,
	    pageSize = props.pageSize,
	    total = props.total;

	if (!total) {
		return {};
	} else {
		var start = pageSize * (currentPage - 1) + 1;
		var end = Math.min(start + pageSize - 1, total);
		return { start: start, end: end };
	}
}

var Pagination = exports.Pagination = function (_Component2) {
	_inherits(Pagination, _Component2);

	function Pagination() {
		var _ref2;

		var _temp2, _this2, _ret2;

		_classCallCheck(this, Pagination);

		for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
			args[_key2] = arguments[_key2];
		}

		return _ret2 = (_temp2 = (_this2 = _possibleConstructorReturn(this, (_ref2 = Pagination.__proto__ || Object.getPrototypeOf(Pagination)).call.apply(_ref2, [this].concat(args))), _this2), _this2.renderCount = function () {
			var count = '';
			var _this2$props = _this2.props,
			    currentPage = _this2$props.currentPage,
			    pageSize = _this2$props.pageSize,
			    plural = _this2$props.plural,
			    singular = _this2$props.singular,
			    total = _this2$props.total,
			    label = _this2$props.label;

			if (typeof label === 'function') {
				var params = Object.assign(range(_this2.props), { currentPage: currentPage, pageSize: pageSize, total: total });
				count = label(params);
			} else {
				if (!total) {
					count = 'No ' + (plural || 'records');
				} else if (total > pageSize) {
					var _range = range(_this2.props),
					    start = _range.start,
					    end = _range.end;

					count = 'Showing ' + start + ' to ' + end + ' of ' + total;
				} else {
					count = 'Showing ' + total;
					if (total > 1 && plural) {
						count += ' ' + plural;
					} else if (total === 1 && singular) {
						count += ' ' + singular;
					}
				}
			}
			return _react2.default.createElement(
				'div',
				{ className: 'Pagination__count' },
				count
			);
		}, _this2.onPageSelect = function (page) {
			if (_this2.props.onPageSelect) {
				_this2.props.onPageSelect(page);
			}
		}, _this2.renderPages = function () {
			if (_this2.props.total <= _this2.props.pageSize) return null;

			var pages = [];
			var _this2$props2 = _this2.props,
			    currentPage = _this2$props2.currentPage,
			    pageSize = _this2$props2.pageSize,
			    total = _this2$props2.total,
			    limit = _this2$props2.limit;

			var totalPages = Math.ceil(total / pageSize);
			var minPage = 1;
			var maxPage = totalPages;

			if (limit && limit < totalPages) {
				var rightLimit = Math.floor(limit / 2);
				var leftLimit = rightLimit + limit % 2 - 1;
				minPage = currentPage - leftLimit;
				maxPage = currentPage + rightLimit;

				if (minPage < 1) {
					maxPage = limit;
					minPage = 1;
				}
				if (maxPage > totalPages) {
					minPage = totalPages - limit + 1;
					maxPage = totalPages;
				}
			}
			if (minPage > 1) {
				pages.push(_react2.default.createElement(
					Page,
					{ key: 'page_start', onSelect: _this2.onPageSelect, page: 1 },
					'...'
				));
			}
			for (var page = minPage; page <= maxPage; page++) {
				var selected = page === currentPage;
				/* eslint-disable no-loop-func */
				pages.push(_react2.default.createElement(
					Page,
					{ key: 'page_' + page, selected: selected, onSelect: _this2.onPageSelect, page: page },
					page
				));
				/* eslint-enable */
			}
			if (maxPage < totalPages) {
				pages.push(_react2.default.createElement(
					Page,
					{ key: 'page_end', onSelect: _this2.onPageSelect, page: totalPages },
					'...'
				));
			}
			return _react2.default.createElement(
				'div',
				{ className: 'Pagination__list' },
				pages
			);
		}, _this2.render = function () {
			var className = (0, _classnames2.default)('Pagination', _this2.props.className);
			return _react2.default.createElement(
				'div',
				{ className: className, style: _this2.props.style },
				_this2.renderCount(),
				_this2.renderPages()
			);
		}, _temp2), _possibleConstructorReturn(_this2, _ret2);
	}

	return Pagination;
}(_react.Component);

Pagination.propTypes = {
	className: _propTypes2.default.string,
	currentPage: _propTypes2.default.number.isRequired,
	limit: _propTypes2.default.number,
	label: _propTypes2.default.func,
	onPageSelect: _propTypes2.default.func,
	pageSize: _propTypes2.default.number.isRequired,
	plural: _propTypes2.default.string,
	singular: _propTypes2.default.string,
	style: _propTypes2.default.object,
	total: _propTypes2.default.number.isRequired
};
exports.default = Pagination;